# $Id: 07_shellcmd.t,v 1.2 2007/04/05 09:27:17 pythontech Exp $
use strict;
use Test::More tests => 4;

use lib 't/lib';
use DbUtil;

use PythonTech::Triples::DBHash;
use PythonTech::Triples::ShellCmd;
use DB_File;

my $dbname = 't/new03.3db';

# Create test data
dbwrite($dbname, '
v1 = a
v2 = b
v3 = c
v4 = ="d"
v5 = e
ia = 1
ib = 2
ic = 3
i="d" = 4
ie = 5
l = 5
t1,2,3 = 1
t1,2,4 = 1
t1,5,3 = 1
o1,2 = 3+4
o1,5 = 3
s2,3 = 1
s2,4 = 1
s5,3 = 1
');

my $tr = new PythonTech::Triples::DBHash(filename => $dbname,
					 access => 'r');
my $sh = new PythonTech::Triples::ShellCmd(triples => $tr);

is(&run('info'),"class: PythonTech::Triples::DBHash\nfeatures: \nlast_id: 5\n", 'info');
is(&run('show','a'),"b\tc\nb\t=\"d\"\ne\tc\n", 'show');
is(&run('query','?','?','c'), "a b\na e\n", 'query');
is(&run('ntriples'), "<a> <b> <c> .\n<a> <b> \"\\\"d\\\"\" .\n<a> <e> <c> .\n", 'ntriples');

$tr = undef;
unlink($dbname);

sub qt {
    join(";", sort map {join(",",@$_)} @_);
}

sub j {join(",",sort @_)}

sub run {
    my(@args) = @_;
    if (open(RUN,'-|')) {
	# Parent
	local($/);
	my $output = <RUN>;
	close(RUN);
	return $output;
    } else {
	# Child
	$sh->main('3sh',@args);
	exit;
    }
}
